#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "DLL.ch"

* ------------------------------------------------------------------------- *
//
// simulate PAS Syntax for Array Element
//

// TTPoint=record
//   x,y:integer;
//
#xtranslate .x          => \[1\]
#xtranslate .y          => \[2\]
#xtranslate .z          => \[3\]                 // PAS use for ???
#xtranslate .Color      => \[4\]                 // add Color

// TCircle=record
//   xo,yo,R:single;
//
#xtranslate .xo         => \[1\]
#xtranslate .yo         => \[2\]
#xtranslate .R          => \[3\]

// TRib=record
//   p1,p2:integer;
//
#xtranslate .p1         => \[1\]
#xtranslate .p2         => \[2\]

// TTriangle=record
//   p1,p2,p3:integer;
//
#xtranslate .xx         => \[1\]
#xtranslate .yy         => \[2\]
#xtranslate .zz         => \[3\]

* ------------------------------------------------------------------------- *

#DEFINE nMaxPoints      100
#DEFINE nMaxArray       10240

#DEFINE CRLF            CHR(13)+CHR(10)
#DEFINE false           .F.
#DEFINE true            .T.

* ------------------------------------------------------------------------- *

STATIC snHdll

#command  GDIFUNCTION <Func>([<x,...>]) ;
       => ;
FUNCTION <Func>([<x>]);;
STATIC scHCall := nil ;;
IF scHCall == nil ;;
  IF snHdll == nil ;;
    snHDll := DllLoad('GDI32.DLL') ;;
  ENDIF ;;
  scHCall := DllPrepareCall(snHDll,DLL_STDCALL,<(Func)>) ;;
ENDIF ;;
RETURN DllExecuteCall(scHCall,<x>)

GDIFUNCTION GetPixel( nHDC, x, y)
GDIFUNCTION SetPixel( nHDC, x, y, n )

* ------------------------------------------------------------------------- *

PROCEDURE Appsys
LOCAL cTitle  := "Delaunay Triangulation"
LOCAL hWndDlg := DllCall( "User32.dll", DLL_STDCALL, "FindWindowA", 0, cTitle )
   IF !( hWndDlg == 0 )
      DllCall( "User32.dll", DLL_STDCALL, "SetForegroundWindow", hWndDlg )
      DllCall( "User32.dll", DLL_STDCALL, "BringWindowToTop", hWndDlg )
      DllCall( "User32.dll", DLL_STDCALL, "ShowWindow", hWndDlg, 1 )
      DllCall( "User32.dll", DLL_STDCALL, "UpdateWindow", hWndDlg )
      *** It is a second instance....  Bye Bye
      QUIT
   ENDIF
RETURN

PROCEDURE Main(cPoints)
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg
LOCAL lExit := .F.

   oDlg := DemoDlg():New()
   oDlg:title := "Delaunay Triangulation"
   oDlg:Icon  := 1
   oDlg:minButton := .F.
   oDlg:maxButton := .F.

   oDlg:oPB1:activate  := {|| oDlg:RepaintRibs()   } ; oDlg:oPB1:Setcaption("Repaint Ribs"  )
   oDlg:oPB2:activate  := {|| oDlg:GenPoints(.T.)  } ; oDlg:oPB2:Setcaption("Gen Points"    )
   oDlg:oPB3:activate  := {|| oDlg:Triangulation() } ; oDlg:oPB3:Setcaption("Triangulation" )
   oDlg:oPB4:activate  := {|| oDlg:DrawGradient()  } ; oDlg:oPB4:Setcaption("Draw Gradient" )
   oDlg:oPB5:activate  := {|| oDlg:SavePoints()    } ; oDlg:oPB5:Setcaption("Save Points"   )

   oDlg:Static1:lbDown := {|aPos,uNIL,oSelf| oDlg:ShowColor(aPos)}

   oDlg:close := {|| lExit := .T. }

   IF PCOUNT() > 0
      IF VAL(cPoints) > 0
         oDlg:pointsCount := VAL(cPoints)
      ENDIF
   ENDIF

   oDlg:Create()
   CenterControl(oDlg)

   oDlg:GenPoints(.F.)

   nEvent := xbe_None
   DO WHILE !lExit
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      DO CASE
         CASE nEvent == xbeP_Quit
            Exit

         CASE nEvent == xbeP_Keyboard .AND. mp1 = xbeK_ALT_F4
            Exit

      OTHERWISE
         oXbp:HandleEvent ( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO

   oDlg:Destroy()

RETURN

* ------------------------------------------------------------------------- *

CLASS DemoForm FROM XbpDialog
   EXPORTED:
      VAR oGrp
      VAR oPB1
      VAR oPB2
      VAR oPB3
      VAR oPB4
      VAR oPB5

      VAR Static1
      VAR hDC

      METHOD init
      METHOD create
ENDCLASS

METHOD DemoForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {0,0}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )

   IF Empty(aSize) == .T.
      IF IsMemberVar(self,"ClientSize") == .T.
         aSize := {0,0}
      ELSE
         aSize := {1024,768}
      ENDIF
   ENDIF

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   IF aSize[1] == 0 .AND. aSize[2] == 0
      ::XbpDialog:ClientSize := {1008,734}
   ENDIF
   ::XbpDialog:taskList := .T.
   ::XbpDialog:title := "Neues Formular"

   ::oGrp    := XbpStatic():new( ::drawingArea, , {2,0}, {1004,56}, { { XBP_PP_BGCLR, -255 } } )
   ::oGrp:caption := ""
   ::oGrp:clipSiblings := .T.
   ::oGrp:type := XBPSTATIC_TYPE_GROUPBOX

   ::oPB1    := XbpPushButton():new( ::oGrp, , { 10,6}, {190,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oPB1:caption := ""
   ::oPB1:tabStop := .T.

   ::oPB2    := XbpPushButton():new( ::oGrp, , {210,6}, {190,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oPB2:caption := ""
   ::oPB2:tabStop := .T.

   ::oPB3    := XbpPushButton():new( ::oGrp, , {410,6}, {190,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oPB3:caption := ""
   ::oPB3:tabStop := .T.

   ::oPB4    := XbpPushButton():new( ::oGrp, , {610,6}, {190,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oPB4:caption := ""
   ::oPB4:tabStop := .T.

   ::oPB5    := XbpPushButton():new( ::oGrp, , {810,6}, {190,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oPB5:caption := ""
   ::oPB5:tabStop := .T.

   ::Static1 := XbpStatic():new( ::drawingArea, , {0,56}, {1004,672}, { { XBP_PP_BGCLR, -255 } } )
   ::Static1:Type := XBPSTATIC_TYPE_BITMAP
   ::Static1:clipSiblings := .T.

RETURN self

METHOD DemoForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::oGrp:create()
   ::oPB1:create()
   ::oPB2:create()
   ::oPB3:create()
   ::oPB4:create()
   ::oPB5:create()
   ::Static1:create()

RETURN self

* ------------------------------------------------------------------------- *

CLASS DemoDlg FROM DemoForm
   HIDDEN:
      VAR nTrySolve

   EXPORTED:
      METHOD init
      METHOD create

      METHOD FindPoint()
      METHOD SolveCircle()
      METHOD FindFirstRib()
      METHOD Side()
      METHOD TriangleExists()
      METHOD Triangulation()
      METHOD GenPoints()
      METHOD ClearImage()
      METHOD Circle()
      METHOD Line()
      METHOD DrawGradient()
      METHOD ShowColor()
      METHOD RepaintRibs()
      METHOD SavePoints()
      METHOD TimeGlassOn()
      METHOD TimeGlassOff()
      METHOD Distance()

      VAR oPS
      VAR points
      VAR pointsCount
      VAR UserPoints
      VAR Triangles
      VAR TrianglesCount
      VAR Ribs
      VAR RibsCount
      VAR lFlagCircle
      VAR lScreenEdge

ENDCLASS

METHOD DemoDlg:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::DemoForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::pointsCount  := nMaxPoints
   ::lFlagCircle  := .F.                         // solve Circle
   ::nTrySolve    := 0                           // solve Counter
   ::lScreenEdge  := .T.                         // add 4 Points at Edge

RETURN self

METHOD DemoDlg:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
LOCAL aStat

   ::DemoForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   // save if User have change default 100 Points to generate
   ::UserPoints := ::pointsCount

   aStat := ::Static1:CurrentSize()

   // make the presentation space and assign to Device
   //
   ::oPS := XBpPresSpace():New()
   ::oPS:Create(::Static1:WinDevice())
   ::oPS:mode := XBPPS_MODE_HIGH_PRECISION

   // hDC need for DLLcall
   //
   ::hDC := ::Static1:winDevice():getHDC()

   ::RibsCount       := 0
   ::Ribs            := Array(nMaxArray,2)
   AFILL(::Ribs.x,0)
   AFILL(::Ribs.y,0)

   ::TrianglesCount  := 0
   ::Triangles       := Array(nMaxArray,3)
   AFILL(::Triangles.xx,0)
   AFILL(::Triangles.yy,0)
   AFILL(::Triangles.zz,0)

   ::oPB1:disable()
   ::oPB4:disable()
   ::oPB5:disable()

   ::show()

RETURN self

METHOD DemoDlg:FindPoint(r1,r2)
LOCAL i,j
LOCAL cr
LOCAL b
LOCAL x2,y2,v
LOCAL nRet := -1
LOCAL bSaveError, oError
LOCAL lBreak := .F.
LOCAL aPoints := ::points
LOCAL nSeconds
LOCAL nPointsCount := ::PointsCount

   IF r1 = NIL ; RETURN(0) ; ENDIF
   IF r2 = NIL ; RETURN(0) ; ENDIF

//   bSaveError := ErrorBlock()
//   ErrorBlock( {|e| Break(e)} )
BEGIN SEQUENCE

nSeconds := Seconds()

      FOR i := 1 TO nPointsCount
         IF .NOT. ::TriangleExists(r1,r2,i)
            IF i<>r1 .AND. i<>r2

               cr := ::SolveCircle(aPoints[r1].x,aPoints[r1].y,;
                                   aPoints[r2].x,aPoints[r2].y,;
                                   aPoints[ i].x,aPoints[ i].y )

               b := .T.
               FOR j := 1 TO nPointsCount
                  IF (j<>r1) .AND. (j<>r2) .AND. (j<>i)
                     x2 := aPoints[j].x - cr.xo
                     y2 := aPoints[j].y - cr.yo
                     v  := SQRT(x2*x2+y2*y2)

                     IF v < cr.R
                        b := false
                        EXIT                     // leave this loop
                     ENDIF
                  ENDIF
               NEXT

               IF b = .T.
                  nRet := i
                  lBreak := .T.
                  BREAK                          // leave all loops
               ENDIF

            ENDIF
         ENDIF
      NEXT

   RECOVER USING oError
//      ErrorBlock( bSaveError )

      IF lBreak = .F.
         Msgbox("Error :"+CRLF+;
              "::points[r1] "+VAR2CHAR(r1)+CRLF+;
              "::points[r2] "+VAR2CHAR(r2)+CRLF+;
              "::points[ i] "+VAR2CHAR( i)+CRLF,"FindPoint")
      ENDIF
   END SEQUENCE
//   ErrorBlock( bSaveError )

RETURN nRet


METHOD DemoDlg:SolveCircle(x1,y1,x2,y2,x3,y3)
LOCAL ma,mb,dx1,dy1,dx2,dy2,dm
LOCAL aRet := {0,0,0}                   // TCircle

   dx1 := x2-x1 ; dy1 := y2-y1
   dx2 := x3-x2 ; dy2 := y3-y2
   IF ABS(dx1)<0.01 ; x1 := x1-0.1 ; dx1 := x2-x1 ; ENDIF
   IF ABS(dx2)<0.01 ; x3 := x3+0.1 ; dx2 := x3-x2 ; ENDIF
   IF ABS(dy1)<0.01 ; y1 := y1-0.1 ; dy1 := y2-y1 ; ENDIF
   IF ABS(dy2)<0.01 ; y3 := y3+0.1 ; dy2 := y3-y2 ; ENDIF
   ma := dy1/dx1
   mb := dy2/dx2
   dm := mb-ma
   IF ABS(dm)<0.0000001 ; y3 := y3+0.1 ; dy2 := y3-y2 ; mb := dy2/dx2 ; dm := mb-ma ; ENDIF
   aRet.xo := (ma*mb*(y1-y3)+mb*(x1+x2)-ma*(x2+x3))*0.5/dm
   aRet.yo := -1/mb*(aRet.xo-(x2+x3)*0.5)+(y2+y3)*0.5
   dx1 := x1 - aRet.xo
   dy1 := y1 - aRet.yo
   aRet.R := sqrt(dx1*dx1+dy1*dy1)

   IF ::lFlagCircle = .T.
      ::Circle(aRet.xo,aRet.yo,aRet.R,GRA_CLR_PALEGRAY,GRA_LINETYPE_DOT)
   ENDIF

   ::nTrySolve++

RETURN aRet

METHOD DemoDlg:FindFirstRib()
LOCAL i,j,k,n
LOCAL st_1,st_0

   FOR i := 1 TO ::pointsCount-1                 // 1000
      FOR j := i+1 TO ::pointsCount              // 1000*1000
         st_1 := false
         st_0 := false
         FOR k := 1 to ::pointsCount             // 1000*1000*1000 ... hm
            IF (k<>i) .AND. (k<>j)
               n := ::Side(i,j,k)
               IF n=1 ; st_1 := true ; ENDIF
               IF n=0 ; st_0 := true ; ENDIF
            ENDIF
         NEXT

         IF .NOT. (st_1 .AND. st_0)
            ::Ribs[1].p1 := i
            ::Ribs[1].p2 := j
            ::RibsCount  := 1

            ::Line(::Points[i].x,::Points[i].y,::Points[j].x,::Points[j].y, GRA_CLR_RED)

            EXIT
         ENDIF
      NEXT
   NEXT

RETURN

METHOD DemoDlg:Side(i,j,k)
LOCAL x1,y1,x2,y2,xo,yo,dx,dy,a,b,v
LOCAL nRet := -1

   x1 := ::Points[i].x
   y1 := ::Points[i].y
   x2 := ::Points[j].x
   y2 := ::Points[j].y
   xo := ::Points[k].x
   yo := ::Points[k].y
   dx := x2-x1
   dy := y2-y1
   IF ABS(dx) > ABS(dy)
      a := dy/dx
      b := y1-a*x1
      v := a*xo+b
      IF yo > v
         nRet := 0
      ELSE
         nRet := 1
      ENDIF
   ELSE
      a := dx/dy
      b := x1-a*y1
      v := a*yo+b
      IF xo > v
         nRet := 0
      ELSE
         nRet := 1
      ENDIF
   ENDIF

RETURN nRet

METHOD DemoDlg:TriangleExists(p1,p2,p3)
LOCAL i
LOCAL X1 := .F.
LOCAL X2 := .F.
LOCAL X3 := .F.
LOCAL nTrianglesCount := ::TrianglesCount
LOCAL aTriangles := ::triangles

   FOR i := nTrianglesCount TO 1 STEP -1
      X1 := .F. ; IF ((p1=aTriangles[i].xx) .or. (p1=aTriangles[i].yy) .or. (p1=aTriangles[i].zz)) ; X1 := .T. ; ENDIF
      X2 := .F. ; IF ((p2=aTriangles[i].xx) .or. (p2=aTriangles[i].yy) .or. (p2=aTriangles[i].zz)) ; X2 := .T. ; ENDIF
      X3 := .F. ; IF ((p3=aTriangles[i].xx) .or. (p3=aTriangles[i].yy) .or. (p3=aTriangles[i].zz)) ; X3 := .T. ; ENDIF
      IF X1 .AND. X2 .AND. X3
         RETURN(.T.)
      ENDIF
   NEXT

RETURN .F.


METHOD DemoDlg:Triangulation()
LOCAL i,p1,p2,n
LOCAL X1,Y1,X2,Y2,X3,Y3,j
LOCAL nStart
LOCAL nStop
LOCAL nCalcCount := 0
LOCAL nSeconds

LOCAL bError := ErrorBlock({|e|Break(e)})
LOCAL aRibs := ::Ribs
LOCAL aTriangles := ::Triangles
LOCAL aPoints := ::Points
LOCAL aAttr := Array( GRA_AL_COUNT )

   ::oPB1:disable()
   ::oPB2:disable()
   ::oPB3:disable()
   ::oPB4:disable()
   ::oPB5:disable()

   ::TrianglesCount  := 0                 // reset
   ::nTrySolve       := 0                 // reset

   ::TimeGlassOn( ::DrawingArea )
   nStart := SECONDS()

   ::FindFirstRib()

   i := 1

   aAttr [ GRA_AL_COLOR] := GRA_CLR_PALEGRAY
   GraSetAttrLine( ::oPS, aAttr )


   while (i<::RibsCount+1)

      nCalcCount++

// check Element

      p1 := aRibs[i].p1
      p2 := aRibs[i].p2

// can i use Threads ?

      n  := ::FindPoint(p1,p2)

      IF n > 0
         aRibs[::RibsCount  ].p1 := p1 ; aRibs[::RibsCount  ].p2 := n
         aRibs[::RibsCount+1].p1 := p2 ; aRibs[::RibsCount+1].p2 := n
         ::RibsCount := ::RibsCount+2

         ::TrianglesCount++
         aTriangles[::TrianglesCount].xx := p1
         aTriangles[::TrianglesCount].yy := p2
         aTriangles[::TrianglesCount].zz := n

         ::Line(aPoints[p1].x,aPoints[p1].y,aPoints[ n].x,aPoints[ n].y)   // ::Points[p1].Color)
         ::Line(aPoints[p2].x,aPoints[p2].y,aPoints[ n].x,aPoints[ n].y)   // ::Points[p2].Color)
         ::Line(aPoints[p1].x,aPoints[p1].y,aPoints[p2].x,aPoints[p2].y)   // ::Points[p1].Color)

      ENDIF
      i := i+1

   ENDDO

   nStop := SECONDS()-nStart
   ::TimeGlassOff( ::DrawingArea )

   // Debug with low Number -> do not show Msgbox()
   //
   IF ::pointsCount > 50
      Msgbox("ready ... "+LTRIM(STR(nStop))+" Sec."+CRLF+;
             "for "+LTRIM(STR(::pointsCount))+ " Points"+CRLF+;
             "calc "+LTRIM(STR(nCalcCount))+CRLF+;
             "TriAngle "+LTRIM(STR(::TrianglesCount))+CRLF+;
             "Try solve "+LTRIM(STR(::nTrySolve)),;
             "Triangulation()" )
   ENDIF

   ::oPB1:enable()
   ::oPB2:enable()
   ::oPB3:enable()
   ::oPB4:enable()
   ::oPB5:enable()

ErrorBlock(bError)

RETURN

METHOD DemoDlg:GenPoints(lNew)
LOCAL i,j
LOCAL aSize := ::Static1:CurrentSize()
LOCAL mX,mY
LOCAL nColor   := 0
LOCAL lUseDBF  := .F.
LOCAL aRGB     := RGB_COLOR()
LOCAL iMax     := LEN(aRGB)

   IF EMPTY(lNew)
      IF FILE("POINTS.DBF")
         USE POINTS.DBF EXCLUSIVE
         ::pointsCount := LASTREC()
         lUseDBF       := .T.
         ::lScreenEdge := .F.
      ELSE
         ::lScreenEdge := .T.
         ::pointsCount := ::UserPoints -4
         lUseDBF       := .F.
      ENDIF
   ELSE
      ::lScreenEdge    := .T.
      ::pointsCount    := ::UserPoints -4
      lUseDBF          := .F.
   ENDIF


   // reset
   //
   ::points := {}

   AFILL(::Triangles.xx,0)
   AFILL(::Triangles.yy,0)
   AFILL(::Triangles.zz,0)

   AFILL(::Ribs.x,0)
   AFILL(::Ribs.y,0)

   ::ClearImage()

   ::oPB1:disable()
   ::oPB4:disable()
   ::oPB5:disable()

   IF ::pointsCount  < 12 .AND. lUseDBF = .F.
      Msgbox("less than 12 Points might fail")
      RunShell("","DLT.EXE",.T.,.F.)             // get App "toFront"
      ::pointsCount := 12

   ELSEIF ::pointsCount > 110
      Msgbox("WARNING : "+LTRIM(STR(::pointsCount))+" Points may take Hours to calculate !")
      RunShell("","DLT.EXE",.T.,.F.)             // get App "toFront"

   ENDIF

   SetAppWindow(self)
   SetAppFocus(::Static1)

   ::TimeGlassOn( ::DrawingArea )

   FOR i := 1 TO ::PointsCount

      IF lUseDBF = .F.
         mX := RANDOMINT( 1, aSize[1]-2)
         mY := RANDOMINT( 1, aSize[2]-2)
         nColor := aRGB[ RANDOMINT( 1, iMax) ]
      ELSE
         mX := POINTS->PX
         mY := POINTS->PY
         nColor := POINTS->COLOR
      ENDIF
      AADD(::points,{mX,mY,i,nColor})

      // use FILL Option
      //
      ::Circle(mX,mY,3,nColor,,.T.)

      IF lUseDBF = .T.
         SKIP
      ENDIF
   NEXT

   // hole Screen using Edge Points
   //
   IF ::lScreenEdge = .T.
      // fill Screen
      //
      AADD(::points,{       0,       0,0,nColor}) ; ::Circle(       0,       0,3,nColor,,.T.)
      AADD(::points,{aSize[1],       0,0,nColor}) ; ::Circle(aSize[1],       0,3,nColor,,.T.)
      AADD(::points,{aSize[1],aSize[2],0,nColor}) ; ::Circle(aSize[1],aSize[2],3,nColor,,.T.)
      AADD(::points,{       0,aSize[2],0,nColor}) ; ::Circle(       0,aSize[2],3,nColor,,.T.)
   ENDIF

   ::pointsCount := LEN(::points)

   IF lUseDBF = .T.
      CLOSE POINTS

      // restore Triangles
      //
      IF FILE("TRIANGLE.DBF")
         USE TRIANGLE.DBF EXCLUSIVE

         ::TrianglesCount := LASTREC()
         j := 0

         DO WHILE !EOF()
            j++
            ::triangles[j] := { TRIANGLE->XX ,;
                                TRIANGLE->YY ,;
                                TRIANGLE->ZZ }
            SKIP
         ENDDO
         CLOSE TRIANGLE

         ::oPB1:enable()

      ENDIF
   ENDIF

   ::TimeGlassOff( ::DrawingArea )

RETURN

METHOD DemoDlg:ClearImage()
LOCAL lRetVal
LOCAL aAttr := Array( GRA_AA_COUNT )      // Array for AREA Attribute
LOCAL aSize := ::Static1:CurrentSize()

   aAttr [ GRA_AA_COLOR    ] := GRA_CLR_WHITE
   GraSetAttrArea( ::oPS, aAttr )
   GraBox( ::oPS, {0,0} , aSize, GRA_FILL  )

RETURN lRetVal

METHOD DemoDlg:Circle(X0,Y0,R0,nColor,nLineType,lFill)
LOCAL aAttr := Array( GRA_AL_COUNT )      // Array for Line Attribute
LOCAL aArea := Array( GRA_AA_COUNT )      // Array for AREA Attribute
LOCAL bSaveError, oError

   IF !EMPTY(nLineType)
      aAttr [ GRA_AL_TYPE ] := nLineType
   ENDIF
   IF !EMPTY(nColor)
      aAttr [ GRA_AL_COLOR] := nColor
      GraSetAttrLine( ::oPS, aAttr )      // set Line Attribute

      aArea [ GRA_AA_COLOR] := nColor
      GraSetAttrArea( ::oPS, aArea )      // set AREA Attribute (need to fill)
   ENDIF

   bSaveError := ErrorBlock()
   ErrorBlock( {|e| Break(e)} )

   BEGIN SEQUENCE

      IF VALTYPE(X0) <> "N" ; BREAK ; ENDIF
      IF VALTYPE(Y0) <> "N" ; BREAK ; ENDIF
      IF VALTYPE(R0) <> "N" ; BREAK ; ENDIF

      IF EMPTY(lFill)
         GraArc( ::oPS, {X0,Y0}, R0)
      ELSE
         GraArc( ::oPS, {X0,Y0}, R0 ,,,, GRA_FILL )
      ENDIF

   RECOVER USING oError
      ErrorBlock( bSaveError )

      Msgbox("Error :"+CRLF+;
           "X0 "+VAR2CHAR(X0)+CRLF+;
           "Y0 "+VAR2CHAR(Y0)+CRLF+;
           "R0 "+VAR2CHAR(R0)+CRLF,"Circle")
   END SEQUENCE
   ErrorBlock( bSaveError )

RETURN nil

METHOD DemoDlg:Line(X1,Y1,X2,Y2,nColor,nLineType)
LOCAL aAttr := Array( GRA_AL_COUNT )      // Array for Line Attribute
LOCAL bSaveError, oError

   IF !EMPTY(nLineType)
      aAttr [ GRA_AL_TYPE ] := nLineType
   ENDIF
   IF !EMPTY(nColor)
      aAttr [ GRA_AL_COLOR] := nColor
      GraSetAttrLine( ::oPS, aAttr )      // set Line Attribute
   ENDIF

//   bSaveError := ErrorBlock()
//   ErrorBlock( {|e| Break(e)} )

   BEGIN SEQUENCE
      IF VALTYPE(X1) <> "N" ; BREAK ; ENDIF
      IF VALTYPE(Y1) <> "N" ; BREAK ; ENDIF
      IF VALTYPE(X2) <> "N" ; BREAK ; ENDIF
      IF VALTYPE(Y2) <> "N" ; BREAK ; ENDIF

      GraLine( ::oPS, {X1,Y1}, {X2,Y2} )

   RECOVER USING oError
      ErrorBlock( bSaveError )

      Msgbox("Error :"+CRLF+;
           "X1 "+VAR2CHAR(X1)+CRLF+;
           "Y1 "+VAR2CHAR(Y1)+CRLF+;
           "X2 "+VAR2CHAR(X2)+CRLF+;
           "Y2 "+VAR2CHAR(Y2)+CRLF,"Line")

   END SEQUENCE
//   ErrorBlock( bSaveError )

RETURN nil

METHOD DemoDlg:DrawGradient()
LOCAL X1,Y1,X2,Y2,X3,Y3,j
LOCAL aColors  := {}
LOCAL nColor1  := GRA_CLR_WHITE
LOCAL nColor2  := GRA_CLR_WHITE
LOCAL nColor3  := GRA_CLR_WHITE

   FOR j := 1 TO ::TrianglesCount

      IF ::triangles[j].xx * ::triangles[j].yy * ::triangles[j].zz = 0
         EXIT
      ELSE

         X1 := ::Points[ ::triangles[j].xx ].x
         Y1 := ::Points[ ::triangles[j].xx ].y

         X2 := ::Points[ ::triangles[j].yy ].x
         Y2 := ::Points[ ::triangles[j].yy ].y

         X3 := ::Points[ ::triangles[j].zz ].x
         Y3 := ::Points[ ::triangles[j].zz ].y

         nColor1 := ::Points[ ::triangles[j].xx ].Color
         nColor2 := ::Points[ ::triangles[j].yy ].Color
         nColor3 := ::Points[ ::triangles[j].zz ].Color

         aColors := {nColor1,nColor2,nColor3 }
         GraGradient(::oPS, {X1,Y1}, {{X2,Y2}, {X3,Y3}}, aColors, GRA_GRADIENT_TRIANGLE)

      ENDIF
   NEXT

RETURN NIL

METHOD DemoDlg:ShowColor(aPos)
LOCAL nColor := GetPixel(::hDC,aPos[1],aPos[2])
LOCAL aRGB   := GraGetRGBIntensity(AutomationTranslateColor(nColor,.T.))

   Msgbox("Color "+VAR2CHAR(aRGB),"Position "+VAR2CHAR(aPos) )
RETURN nil

METHOD DemoDlg:RepaintRibs()
LOCAL X1,Y1,X2,Y2,X3,Y3,j
LOCAL nColor1,nColor2,nColor3

   ::ClearImage()

   ::TimeGlassOn( ::DrawingArea )

   FOR j := 1 TO ::TrianglesCount

      IF ::triangles[j].xx * ::triangles[j].yy * ::triangles[j].zz = 0
          EXIT
      ELSE

         X1 := ::Points[ ::triangles[j].xx ].x
         Y1 := ::Points[ ::triangles[j].xx ].y
         X2 := ::Points[ ::triangles[j].yy ].x
         Y2 := ::Points[ ::triangles[j].yy ].y
         X3 := ::Points[ ::triangles[j].zz ].x
         Y3 := ::Points[ ::triangles[j].zz ].y

         nColor1 := ::Points[ ::triangles[j].xx ].Color
         nColor2 := ::Points[ ::triangles[j].yy ].Color
         nColor3 := ::Points[ ::triangles[j].zz ].Color

         ::Circle(X1,Y1,3,nColor1,,.T.)
         ::Circle(X2,Y2,3,nColor2,,.T.)
         ::Circle(X3,Y3,3,nColor3,,.T.)

         ::Line(X1,Y1,X2,Y2,GRA_CLR_PALEGRAY)   // nColor1)
         ::Line(X1,Y1,X3,Y3,GRA_CLR_PALEGRAY)   // nColor2)
         ::Line(X2,Y2,X3,Y3,GRA_CLR_PALEGRAY)   // nColor3)

      ENDIF
   NEXT

   ::TimeGlassOff( ::DrawingArea )

   ::oPB4:enable()
   ::oPB5:enable()

RETURN

METHOD DemoDlg:SavePoints()
LOCAL i,j

   IF .NOT. FILE("POINTS.DBF")
      CRE_POINTS("POINTS.DBF")
   ENDIF
   USE POINTS.DBF EXCLUSIVE
   ZAP

   FOR i := 1 TO LEN(::points)
      APPEND BLANK

      REPLACE POINTS->NUM   WITH i
      REPLACE POINTS->PX    WITH ::points[i].xx
      REPLACE POINTS->PY    WITH ::points[i].yy
      REPLACE POINTS->PZ    WITH ::points[i].zz
      REPLACE POINTS->COLOR WITH ::points[i].Color
   NEXT
   CLOSE POINTS

/***************************************************************************
*    IF .NOT. FILE("RIBS.DBF")
*       CRE_RIBS("RIBS.DBF")
*    ENDIF
*    USE RIBS.DBF EXCLUSIVE
*    ZAP
*
*    FOR j := 1 TO ::TrianglesCount
*
*       IF ::triangles[j].xx * ::triangles[j].yy * ::triangles[j].zz = 0
*           EXIT
*       ELSE
*          APPEND BLANK
*
*          REPLACE RIBS->NUM    WITH j
*          REPLACE RIBS->PX1    WITH ::Points[ ::triangles[j].xx ].x
*          REPLACE RIBS->PY1    WITH ::Points[ ::triangles[j].xx ].y
*          REPLACE RIBS->PY1    WITH ::Points[ ::triangles[j].yy ].x
*          REPLACE RIBS->PY2    WITH ::Points[ ::triangles[j].yy ].y
*          REPLACE RIBS->PX3    WITH ::Points[ ::triangles[j].zz ].x
*          REPLACE RIBS->PY3    WITH ::Points[ ::triangles[j].zz ].y
*
*          REPLACE RIBS->COLOR1 WITH ::Points[ ::triangles[j].xx ].Color
*          REPLACE RIBS->COLOR2 WITH ::Points[ ::triangles[j].yy ].Color
*          REPLACE RIBS->COLOR3 WITH ::Points[ ::triangles[j].zz ].Color
*
*       ENDIF
*    NEXT
*    CLOSE RIBS
***************************************************************************/

   IF .NOT. FILE("TRIANGLE.DBF")
      CRE_TRIANGLE("TRIANGLE.DBF")
   ENDIF
   USE TRIANGLE.DBF EXCLUSIVE
   ZAP

   FOR j := 1 TO ::TrianglesCount

      IF ::triangles[j].xx * ::triangles[j].yy * ::triangles[j].zz = 0
          EXIT
      ELSE
         APPEND BLANK
         REPLACE TRIANGLE->NUM WITH j
         REPLACE TRIANGLE->XX  WITH ::triangles[j].xx
         REPLACE TRIANGLE->YY  WITH ::triangles[j].yy
         REPLACE TRIANGLE->ZZ  WITH ::triangles[j].zz
      ENDIF
   NEXT
   CLOSE TRIANGLE

   Msgbox("save "+LTRIM(STR(::PointsCount   ))+" points"+CRLF+;
          "Ribs "+LTRIM(STR(::TrianglesCount))+" Triangles","Save Data")
RETURN

METHOD DemoDlg:TimeGlassOn( oXbp, lChild )
LOCAL aChildlist := oxbp:childlist()

   DEFAULT lChild TO .F.

   IF ISMETHOD( oXbp, "setpointer" ) .AND. ( !oXbp:isDerivedFrom( "XbpDialog" ) .OR. !oXbp:isDerivedFrom( "XbpDialogEx" ) )
      oXbp:setpointer(, XBPSTATIC_SYSICON_WAIT, XBPWINDOW_POINTERTYPE_SYSPOINTER )
   ENDIF
   IF VALTYPE( aChildList ) = 'A'
      IF lChild = .T.
      ENDIF
      AEVAL( aChildlist, { | o | ::TimeGlassOn( o ) } )
   ENDIF
*   ::Static1:lockUpdate(.T.)

RETURN

METHOD DemoDlg:TimeGlassOff( oXbp, lChild )
LOCAL aChildlist := oxbp:childlist()

   DEFAULT lChild TO .F.

   IF ISMETHOD( oXbp, "setpointer" ) .AND. ( !oXbp:isDerivedFrom( "XbpDialog" ) .OR. !oXbp:isDerivedFrom( "XbpDialogEx" ) )
      oXbp:setpointer(, XBPSTATIC_SYSICON_ARROW, XBPWINDOW_POINTERTYPE_SYSPOINTER )
   ENDIF
   IF VALTYPE( aChildList ) = 'A'
      AEVAL( aChildlist, { | o | ::TimeGlassOff( o ) } )
      IF lChild = .T.
      ENDIF
   ENDIF
*   ::Static1:lockUpdate(.F.)
*   ::Static1:invalidateRect()

RETURN

METHOD DemoDlg:Distance(aPos1,aPos2)
/* Local variable declaration */
LOCAL nLen:=Len(aPos1), i, nTotal

/* For 1,2,3, or notional Dimensions, perform a Distance calculation */
  nTotal:=0
  FOR i:=1 TO len(aPos1)
    nTotal+=((aPos1[i]-aPos2[i])^2)
  NEXT i

RETURN Sqrt(nTotal)

* ------------------------------------------------------------------------- *

FUNCTION CRE_POINTS(datei,alias,id)
LOCAL p,field_list:={}
  IF VALTYPE(datei)!="C"
    datei := "POINTS.DBF"
  ENDIF
  IF VALTYPE(alias)!="C"
    p := AT(".",datei)
    alias := IF(p>0,SUBSTR(datei,1,p-1),datei)
  ENDIF
  IF VALTYPE(id)!="N"
    id := 0
  ENDIF
  SELECT (id)
  IF !FILE(datei)
    AADD(field_list,{"NUM"  ,"N", 5,0})
    AADD(field_list,{"PX"   ,"N", 5,0})
    AADD(field_list,{"PY"   ,"N", 5,0})
    AADD(field_list,{"PZ"   ,"N", 5,0})
    AADD(field_list,{"COLOR","N",10,0})
    DBCREATE(datei,field_list,"DBFNTX")
  ENDIF
RETURN(.t.)

FUNCTION CRE_RIBS(datei,alias,id)
LOCAL p,field_list:={}
  IF VALTYPE(datei)!="C"
    datei := "RIBS.DBF"
  ENDIF
  IF VALTYPE(alias)!="C"
    p := AT(".",datei)
    alias := IF(p>0,SUBSTR(datei,1,p-1),datei)
  ENDIF
  IF VALTYPE(id)!="N"
    id := 0
  ENDIF
  SELECT (id)
  IF !FILE(datei)
    AADD(field_list,{"NUM","N",5,0})
    AADD(field_list,{"PX1","N",5,0})
    AADD(field_list,{"PY1","N",5,0})
    AADD(field_list,{"PX2","N",5,0})
    AADD(field_list,{"PY2","N",5,0})
    AADD(field_list,{"PX3","N",5,0})
    AADD(field_list,{"PY3","N",5,0})
    AADD(field_list,{"COLOR1","N",10,0})
    AADD(field_list,{"COLOR2","N",10,0})
    AADD(field_list,{"COLOR3","N",10,0})
    AADD(field_list,{"PID","C",20,0})
    DBCREATE(datei,field_list,"DBFNTX")
  ENDIF
RETURN(.t.)

FUNCTION CRE_TRIANGLE(datei,alias,id)
  LOCAL p,field_list:={}
  IF VALTYPE(datei)!="C"
    datei := "TRIANGLE.DBF"
  ENDIF
  IF VALTYPE(alias)!="C"
    p := AT(".",datei)
    alias := IF(p>0,SUBSTR(datei,1,p-1),datei)
  ENDIF
  IF VALTYPE(id)!="N"
    id := 0
  ENDIF
  SELECT (id)
  IF !FILE(datei)
    AADD(field_list,{"NUM","N",5,0})
    AADD(field_list,{"XX" ,"N",5,0})
    AADD(field_list,{"YY" ,"N",5,0})
    AADD(field_list,{"ZZ" ,"N",5,0})
    DBCREATE(datei,field_list,"DBFNTX")
  ENDIF
RETURN(.t.)

FUNCTION RGB_COLOR()
LOCAL aRet := {}

   AADD(aRet,GraMakeRGBColor({255,000,000}))     // Red
   AADD(aRet,GraMakeRGBColor({255,128,000}))     // Red-Yellow
   AADD(aRet,GraMakeRGBColor({255,255,000}))     // Yello
   AADD(aRet,GraMakeRGBColor({128,255,000}))     // Yello-Green
   AADD(aRet,GraMakeRGBColor({000,255,000}))     // Green
   AADD(aRet,GraMakeRGBColor({000,255,128}))     // Green-Cyan
   AADD(aRet,GraMakeRGBColor({000,255,255}))     // Cyan
   AADD(aRet,GraMakeRGBColor({000,128,255}))     // Cyan-Blue
   AADD(aRet,GraMakeRGBColor({000,000,255}))     // Blue
   AADD(aRet,GraMakeRGBColor({128,000,255}))     // Blue-Pink
   AADD(aRet,GraMakeRGBColor({255,000,255}))     // Pink
   AADD(aRet,GraMakeRGBColor({255,000,128}))     // Pink-Red


RETURN aRet


//EOF
/////
